import java.io.*;
public class Extract
{

    public Extract(RandomAccessFile hed,RandomAccessFile wad,String folder,int version){
        
        try{
        
        int tempByte,number = 0;
        long offset,length;
        RandomAccessFile file = null;
        String name,directory;
        byte[] buffer;
        System.out.printf("\n%-6s%10s%10s   %s\n", "Number","Offset","Length","Name");
        while (true){
            
            name = "";

            //Signed Int to unsigned int( stored in a signed long :( , damn java... )
            //longVal = ((long)intval << 32) >>> 32; //filling zeros on upper 32 bit
            offset = ((long)Integer.reverseBytes(hed.readInt()) << 32) >>> 32;//Read a signed int and convert to unsigned
            if (offset == 0xFFFFFFFFL){ //we reached EOF marker
                break;
            }
            
            if ( version != 1){ //thug2 is 1
                if (version != 9){
                    if ( version == 3){ //thaw+alt
                        if (offset < 0xF000000L){
                            System.out.println("Error: This is not a thaw(alt) wad.");
                            wad.close();
                            hed.close();
                            System.exit(0);
                        }
                        offset -= 0xF000000L;
                    }
                    if (offset >= 0xFFF00000L){
                        offset -= 0xFFE00000L;
                    }
                }
                offset *= 0x800L;
            }           
            
            //length = Integer.reverseBytes(hed.readInt()); //Hopefully noone has a file larger than 2gb inside a wad...
            length = ((long)Integer.reverseBytes(hed.readInt()) << 32) >>> 32; //Nevermind :)
            
            while(true){
                tempByte = hed.read();
                if (tempByte == 0){
                    break;
                }
                name += (char)tempByte;
            }
            

            //System.out.println( 4 - (name.length() % 4));  //How many bytes to skip
            //hed.skipBytes( (4 - (name.length() % 4)) - 1); //The negative will be skiped and that is not good, so use the following
            hed.seek(hed.getFilePointer() + ( 3 - (name.length() % 4)) );
            
            
            if ((number % 100 == 0)|(length >= 0x1FFFFFFFL)){
                System.out.printf("%-6d%10X%10X   %s\n", number, offset, length , name);

            }

            directory = folder + name;
            directory = directory.substring(0, directory.lastIndexOf("\\"));
            new File(directory).mkdirs();
            file = new RandomAccessFile(folder + name, "rw");
            file.setLength(0); //delete previous data
            wad.seek(offset);
            //copy file
            while (length > 0L){
                if (length >= 0x100000L){
                    buffer = new byte[0x100000];
                    length -= 0x100000L;
                }else{
                    buffer = new byte[(int)length]; //we should always be below 0x100000 bytes here
                    length = 0L;
                }
                //System.out.println(buffer.length);
                wad.read(buffer);
                file.write(buffer);
            }
            file.close();
            number++;

        }
        
        System.out.println("Finished Extracting Files");
        
    }catch (Exception e){
        System.out.println("Error in extract function");
        System.out.println(e);
    }
    }
}
