import java.util.Scanner;
import java.io.RandomAccessFile;
import java.io.IOException;


public class Main
{

    public static void main(String[] args)
    {
        int version = 0;
        
        System.out.println("WadEdit v4 by Zmathue 2010\n");
        
        if (args.length != 5){
            System.out.println("Usage: java WadEdit (B/E) Version WadFile HedFile Folder");
            System.out.println("Extracing:  java WadEdit B 1 Input.Wad Input.Hed OutputFolder");
            System.out.println("Building:  java WadEdit E 1 Output.Wad Output.Hed InputFolder\n");
            System.out.println("Use B for building and E for extracting.\n");
            System.out.println("Wad Versions: \n1-Thug2 and older (4gb max wad and file size)\n2-Thaw and newer (4gb max wad and file size)\n3-Thaw and newer alternative (this is used for the music wad's)(3.76gb max wad size but 4gb file size, its kinda ironic)\n9-Custom version of thaw's with a 8192gb max wad size (game won't use it though :( )");
            System.out.println("Note: All output files and folders will be overwritten.");
            System.exit(0);
            //System.out.println(args[0]);
        }
        
        if ( !((args[0].equals("b"))|(args[0].equals("B"))|(args[0].equals("e"))|(args[0].equals("E")))){
                System.out.println("\""  + args[0] + "\" is an invalid flag.");
                System.exit(0);
        }
        
        String folder = args[4], wadversion = args[1];
        
        RandomAccessFile hed = null ,wad = null;
        
        try{
            version = Integer.parseInt(args[1]);
        }catch(Exception e){
            System.out.println("Invalid number for game version."); 
            System.exit(0);
        }
        
        if ( ((version >= 4)|(version <= 0))&(version != 9) ){
            System.out.println("Invalid number for game version."); 
            System.exit(0);             
        }
         
        try {    

            
            if ((args[0].equals("b"))|(args[0].equals("B"))){
                hed = new RandomAccessFile(args[3], "rw");
                wad = new RandomAccessFile(args[2], "rw");
                hed.setLength(0);   //delete previous data
                wad.setLength(0);
                new Build(hed,wad,folder,version);
            }else if ((args[0].equals("e"))|(args[0].equals("E"))){
                hed = new RandomAccessFile(args[3], "r");
                wad = new RandomAccessFile(args[2], "r");
                new Extract(hed,wad,folder,version);
            }       
            
        }catch (IOException e){
            System.out.println("Error with file or path.");
            System.out.println(e);
        }finally{
            try{
                if (hed != null) {
                    hed.close();
                }
                if (wad != null) {
                    wad.close();
                }
            }catch (IOException Ignored){
            }
        }

              
        
    }
}
